﻿using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using ClientServer.Db;

namespace ClientServer.Migrations
{
    [DbContext(typeof(YapexDbContext))]
    [Migration("20160921124646_final1")]
    partial class final1
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
            modelBuilder
                .HasAnnotation("ProductVersion", "1.0.0-rtm-21431");

            modelBuilder.Entity("ClientServer.Models.AwaitDummy", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.HasKey("Id");

                    b.ToTable("AwaitDummies");
                });

            modelBuilder.Entity("ClientServer.Models.ContentType", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("Type");

                    b.HasKey("Id");

                    b.ToTable("ContentTypes");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Asset", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AssetUrl");

                    b.Property<byte[]>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<int?>("ExerciseDescriptionId")
                        .IsRequired();

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("MimeType");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseDescriptionId");

                    b.ToTable("Assets");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.CodeTemplate", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("ExerciseId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int?>("MainFileId");

                    b.Property<int>("PLangId");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseId");

                    b.HasIndex("MainFileId")
                        .IsUnique();

                    b.HasIndex("PLangId");

                    b.ToTable("Templates");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Exercise", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("CanUserCreateCustomTests");

                    b.Property<bool>("CanUserCreateFiles");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<bool>("IsOnlyVisibleToMe");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("ShortDescription");

                    b.Property<bool>("ShouldShowSubmitResult");

                    b.Property<int>("UserGroupId");

                    b.Property<int?>("UserId");

                    b.HasKey("Id");

                    b.HasIndex("UserGroupId");

                    b.HasIndex("UserId");

                    b.ToTable("Exercises");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.ExerciseDescription", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("ExerciseId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseId")
                        .IsUnique();

                    b.ToTable("ExerciseDescriptions");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.MetaData", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("ExerciseId");

                    b.Property<int?>("ExerciseId1");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseId")
                        .IsUnique();

                    b.HasIndex("ExerciseId1");

                    b.ToTable("MetaDatas");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Release.ExerciseRelease", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime?>("AutomaticEndAt");

                    b.Property<DateTime?>("AutomaticStartAt");

                    b.Property<int>("AvailableWorkingTimeInMinutes");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("ExerciseId");

                    b.Property<string>("GeneratedCode")
                        .IsRequired();

                    b.Property<bool>("HadAutomaticAssessmentErrors");

                    b.Property<bool>("HasAutomaticAssessmentFinished");

                    b.Property<bool>("HasAutomaticAssessmentStarted");

                    b.Property<bool>("HasLimitedWorkingTime");

                    b.Property<bool>("IsReleased");

                    b.Property<bool>("IsVisibleToAllAfterRelease");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("Note");

                    b.Property<int?>("PLangId");

                    b.Property<int>("ReleaseDurationType");

                    b.Property<int>("ReleaseStartType");

                    b.Property<DateTime?>("ReleasedAt");

                    b.Property<bool>("RunAlsoNormalTests");

                    b.Property<bool>("ShouldAutomaticAssessSubmissions");

                    b.HasKey("Id");

                    b.HasAlternateKey("GeneratedCode")
                        .HasName("Unique_GeneratedCode");

                    b.HasIndex("ExerciseId");

                    b.HasIndex("PLangId");

                    b.ToTable("ExerciseReleases");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.CustomTestWithSolutionAsTestResult", b =>
                {
                    b.Property<int>("CustomTestId");

                    b.Property<int>("SolutionVersionId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<bool?>("HasCompiled");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<bool?>("Passed");

                    b.Property<int?>("ProgramExitCode");

                    b.Property<string>("Protocol");

                    b.Property<int?>("TestResultCode");

                    b.HasKey("CustomTestId", "SolutionVersionId");

                    b.HasIndex("CustomTestId");

                    b.HasIndex("SolutionVersionId");

                    b.ToTable("CustomTestWithSolutionAsTestResults");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.ExerciseReleaseWithUserAsParticipation", b =>
                {
                    b.Property<int>("UserId");

                    b.Property<int>("ExerciseReleaseId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("LastEditedPLangId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("UserId", "ExerciseReleaseId");

                    b.HasIndex("ExerciseReleaseId");

                    b.HasIndex("LastEditedPLangId");

                    b.HasIndex("UserId");

                    b.ToTable("ExerciseReleaseWithUserAsParticipations");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.Solution", b =>
                {
                    b.Property<int>("UserId");

                    b.Property<int>("ExerciseReleaseId");

                    b.Property<int>("PLangId");

                    b.Property<int?>("AssessmentId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("MainSolutionVersionid");

                    b.HasKey("UserId", "ExerciseReleaseId", "PLangId");

                    b.HasIndex("AssessmentId")
                        .IsUnique();

                    b.HasIndex("PLangId");

                    b.HasIndex("UserId", "ExerciseReleaseId");

                    b.ToTable("Solutions");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionAssessment", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int?>("ManualPoints");

                    b.Property<int>("MaxNormalTestPoints");

                    b.Property<int>("MaxSubmitTestPoints");

                    b.Property<int>("NormalTestPoints");

                    b.Property<string>("Note");

                    b.Property<int?>("SolutionVersionId");

                    b.Property<int>("SubmitTestPoints");

                    b.HasKey("Id");

                    b.HasIndex("SolutionVersionId")
                        .IsUnique();

                    b.ToTable("SolutionAssessment");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionFile", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("DisplayIndex");

                    b.Property<string>("FileNameWithExtension");

                    b.Property<bool>("IsDisplayed");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int?>("SolutionVersionId")
                        .IsRequired();

                    b.Property<int?>("TemplateFileId");

                    b.HasKey("Id");

                    b.HasIndex("SolutionVersionId");

                    b.HasIndex("TemplateFileId");

                    b.ToTable("SolutionFiles");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionVersion", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int?>("MainFileId");

                    b.Property<string>("Note");

                    b.Property<int?>("SolutionExerciseReleaseId")
                        .IsRequired();

                    b.Property<int?>("SolutionPLangId")
                        .IsRequired();

                    b.Property<int?>("SolutionUserId")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("MainFileId")
                        .IsUnique();

                    b.HasIndex("SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId");

                    b.ToTable("SolutionVersions");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.TestWithSolutionAsTestResult", b =>
                {
                    b.Property<int>("TestId");

                    b.Property<int>("SolutionVersionId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<bool?>("HasCompiled");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<bool?>("Passed");

                    b.Property<int?>("ProgramExitCode");

                    b.Property<string>("Protocol");

                    b.Property<int?>("TestResultCode");

                    b.HasKey("TestId", "SolutionVersionId");

                    b.HasIndex("SolutionVersionId");

                    b.HasIndex("TestId");

                    b.ToTable("TestResults");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tag", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName")
                        .IsRequired();

                    b.Property<string>("HtmlColor");

                    b.Property<string>("HtmlIcon");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.HasAlternateKey("DisplayName")
                        .HasName("Unique_Tag");

                    b.ToTable("Tags");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.TagWithMetaData", b =>
                {
                    b.Property<int>("TagId");

                    b.Property<int>("MetaDataId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("TagId", "MetaDataId");

                    b.HasIndex("MetaDataId");

                    b.HasIndex("TagId");

                    b.ToTable("TagWithMetaDatas");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.TemplateFile", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int?>("CodeTemplateId")
                        .IsRequired();

                    b.Property<string>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("DisplayIndex");

                    b.Property<string>("FileNameWithExtension");

                    b.Property<bool>("IsEditableByUser");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.HasIndex("CodeTemplateId");

                    b.ToTable("TemplateFiles");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.CustomTest", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("DisplayIndex");

                    b.Property<string>("DisplayName");

                    b.Property<int>("ExerciseReleaseId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("TestTypeId");

                    b.Property<int>("UserId");

                    b.HasKey("Id");

                    b.HasIndex("TestTypeId");

                    b.HasIndex("UserId", "ExerciseReleaseId");

                    b.ToTable("CustomTest");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.CustomTestAsset", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<byte[]>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int?>("CustomTestId")
                        .IsRequired();

                    b.Property<string>("DisplayName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("MimeType");

                    b.HasKey("Id");

                    b.HasIndex("CustomTestId");

                    b.ToTable("CustomTestAssets");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.DefaultCustomTestSettings", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("ExerciseId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("MaxDiskSpaceInKb");

                    b.Property<int>("MemoryLimitInKb");

                    b.Property<int>("TimeoutInMs");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseId")
                        .IsUnique();

                    b.ToTable("DefaultCustomTestSettings");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.Test", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("DisplayIndex");

                    b.Property<string>("DisplayName");

                    b.Property<int>("ExerciseId");

                    b.Property<bool>("IsSubmitTest");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("TestSettingsId");

                    b.Property<int>("TestTypeId");

                    b.Property<int>("Weight");

                    b.HasKey("Id");

                    b.HasIndex("ExerciseId");

                    b.HasIndex("TestSettingsId")
                        .IsUnique();

                    b.HasIndex("TestTypeId");

                    b.ToTable("Tests");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.TestAsset", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<byte[]>("Content");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("MimeType");

                    b.Property<int?>("TestId")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("TestId");

                    b.ToTable("TestAssets");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.TestSettings", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("MaxDiskSpaceInKb");

                    b.Property<int>("MemoryLimitInKb");

                    b.Property<int>("TimeoutInMs");

                    b.HasKey("Id");

                    b.ToTable("TestCaseSettingses");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.TestType", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<string>("InternalName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("TestTypes");
                });

            modelBuilder.Entity("ClientServer.Models.Lang", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("Language");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("Langs");
                });

            modelBuilder.Entity("ClientServer.Models.PLang", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<string>("InternalName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("PLangs");
                });

            modelBuilder.Entity("ClientServer.Models.Users.ExternalUser", b =>
                {
                    b.Property<int>("ExternalId")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("Email");

                    b.Property<string>("FirstName");

                    b.Property<string>("LastName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<bool>("NeedToRefreshData");

                    b.Property<string>("Token");

                    b.Property<int?>("UserId");

                    b.HasKey("ExternalId");

                    b.HasIndex("UserId")
                        .IsUnique();

                    b.ToTable("ExternalUsers");
                });

            modelBuilder.Entity("ClientServer.Models.Users.GroupRole", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<int>("GroupRolePermissionId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.HasIndex("GroupRolePermissionId")
                        .IsUnique();

                    b.ToTable("GroupRoles");
                });

            modelBuilder.Entity("ClientServer.Models.Users.GroupRolePermission", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("CanAddUserToGroup");

                    b.Property<bool>("CanAssessExercises");

                    b.Property<bool>("CanChangeExercises");

                    b.Property<bool>("CanChangeOtherMembersRole");

                    b.Property<bool>("CanCopyExercises");

                    b.Property<bool>("CanCreateExercises");

                    b.Property<bool>("CanDeleteExercises");

                    b.Property<bool>("CanReleaseExercises");

                    b.Property<bool>("CanRemoveMemberFromGroup");

                    b.Property<bool>("CanSeeExercisesFromOthersInGroup");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("GroupRolePermissions");
                });

            modelBuilder.Entity("ClientServer.Models.Users.Settings.CodeEditorSetting", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("FontSize");

                    b.Property<bool>("HighlightCurrentLine");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<bool>("ShowInvisibles");

                    b.Property<bool>("ShowLineIndentions");

                    b.Property<bool>("ShowLineNumbers");

                    b.Property<int>("TabSize");

                    b.Property<string>("Theme");

                    b.Property<bool>("UseWrapping");

                    b.HasKey("Id");

                    b.ToTable("CodeEditorSettings");
                });

            modelBuilder.Entity("ClientServer.Models.Users.Settings.UserSetting", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("CodeEditorSettingsId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("LangId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("Theme");

                    b.Property<int?>("UserId");

                    b.HasKey("Id");

                    b.HasIndex("CodeEditorSettingsId")
                        .IsUnique();

                    b.HasIndex("LangId");

                    b.HasIndex("UserId")
                        .IsUnique();

                    b.ToTable("UserSettingses");
                });

            modelBuilder.Entity("ClientServer.Models.Users.SystemRole", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<string>("Email");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("SystemRolePermissionId");

                    b.HasKey("Id");

                    b.HasIndex("SystemRolePermissionId")
                        .IsUnique();

                    b.ToTable("SystemRoles");
                });

            modelBuilder.Entity("ClientServer.Models.Users.SystemRolePermission", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("CanChangeGroups");

                    b.Property<bool>("CanChangeOtherUsersSystemRole");

                    b.Property<bool>("CanChangeRoles");

                    b.Property<bool>("CanChangeSystemSettings");

                    b.Property<bool>("CanChangeUserData");

                    b.Property<bool>("CanCreateGroups");

                    b.Property<bool>("CanCreateRoles");

                    b.Property<bool>("CanDeleteActivatedUsers");

                    b.Property<bool>("CanDeleteGroups");

                    b.Property<bool>("CanDeleteRoles");

                    b.Property<bool>("CanManageNewUsers");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("SystemRolePermissions");
                });

            modelBuilder.Entity("ClientServer.Models.Users.SystemSetting", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("DefaultGroupCreatorGroupRoleId");

                    b.Property<int>("DefaultGroupRoleId");

                    b.Property<int>("DefaultUserGroupId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<int>("MaxSolutionVersionsPerUser");

                    b.HasKey("Id");

                    b.HasIndex("DefaultGroupCreatorGroupRoleId")
                        .IsUnique();

                    b.HasIndex("DefaultGroupRoleId")
                        .IsUnique();

                    b.HasIndex("DefaultUserGroupId")
                        .IsUnique();

                    b.ToTable("SystemSettings");
                });

            modelBuilder.Entity("ClientServer.Models.Users.User", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("Email");

                    b.Property<string>("FirstName");

                    b.Property<bool>("IsActivated");

                    b.Property<DateTime>("LastLoginAt");

                    b.Property<string>("LastName");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.Property<string>("Password");

                    b.Property<int?>("SystemRoleId");

                    b.Property<string>("Token")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasAlternateKey("Token")
                        .HasName("Unique_Token");

                    b.HasIndex("SystemRoleId");

                    b.ToTable("Users");
                });

            modelBuilder.Entity("ClientServer.Models.Users.UserGroup", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("CreatedAt");

                    b.Property<string>("DisplayName");

                    b.Property<string>("Email");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("Id");

                    b.ToTable("UserGroups");
                });

            modelBuilder.Entity("ClientServer.Models.Users.UserWithUserGroup", b =>
                {
                    b.Property<int>("UserId");

                    b.Property<int>("UserGroupId");

                    b.Property<DateTime>("CreatedAt");

                    b.Property<int>("GroupRoleId");

                    b.Property<DateTime>("LastUpdatedAt");

                    b.HasKey("UserId", "UserGroupId");

                    b.HasIndex("GroupRoleId");

                    b.HasIndex("UserGroupId");

                    b.HasIndex("UserId");

                    b.ToTable("UserWithUserGroups");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Asset", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.ExerciseDescription")
                        .WithMany("Assets")
                        .HasForeignKey("ExerciseDescriptionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.CodeTemplate", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithMany("CodeTemplates")
                        .HasForeignKey("ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.TemplateFile", "MainFile")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Exercises.CodeTemplate", "MainFileId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.PLang", "PLang")
                        .WithMany()
                        .HasForeignKey("PLangId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Exercise", b =>
                {
                    b.HasOne("ClientServer.Models.Users.UserGroup", "UserGroup")
                        .WithMany("Exercises")
                        .HasForeignKey("UserGroupId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Users.User", "User")
                        .WithMany("Exercises")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.ExerciseDescription", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithOne("Description")
                        .HasForeignKey("ClientServer.Models.Exercises.ExerciseDescription", "ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.MetaData", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise")
                        .WithOne("MetaData")
                        .HasForeignKey("ClientServer.Models.Exercises.MetaData", "ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithMany()
                        .HasForeignKey("ExerciseId1");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Release.ExerciseRelease", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithMany("Releases")
                        .HasForeignKey("ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.PLang", "PLang")
                        .WithMany()
                        .HasForeignKey("PLangId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.CustomTestWithSolutionAsTestResult", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Tests.CustomTest", "CustomTest")
                        .WithMany("TestResults")
                        .HasForeignKey("CustomTestId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionVersion", "SolutionVersion")
                        .WithMany("CustomTestResults")
                        .HasForeignKey("SolutionVersionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.ExerciseReleaseWithUserAsParticipation", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Release.ExerciseRelease", "ExerciseRelease")
                        .WithMany("ExerciseReleaseWithUserAsParticipations")
                        .HasForeignKey("ExerciseReleaseId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.PLang", "LastEditedPLang")
                        .WithMany()
                        .HasForeignKey("LastEditedPLangId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Users.User", "User")
                        .WithMany("ExerciseReleaseWithUserAsParticipations")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.Solution", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionAssessment", "Assessment")
                        .WithOne("Solution")
                        .HasForeignKey("ClientServer.Models.Exercises.Solution.Solution", "AssessmentId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.PLang", "PLang")
                        .WithMany()
                        .HasForeignKey("PLangId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Exercises.Solution.ExerciseReleaseWithUserAsParticipation", "ExerciseReleaseWithUserAsParticipation")
                        .WithMany("Solutions")
                        .HasForeignKey("UserId", "ExerciseReleaseId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionAssessment", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionVersion", "SolutionVersion")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Exercises.Solution.SolutionAssessment", "SolutionVersionId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionFile", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionVersion")
                        .WithMany("SolutionFiles")
                        .HasForeignKey("SolutionVersionId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.TemplateFile", "TemplateFile")
                        .WithMany("SolutionParts")
                        .HasForeignKey("TemplateFileId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.SolutionVersion", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionFile", "MainFile")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Exercises.Solution.SolutionVersion", "MainFileId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Exercises.Solution.Solution")
                        .WithMany("SolutionVersions")
                        .HasForeignKey("SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Solution.TestWithSolutionAsTestResult", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Solution.SolutionVersion", "SolutionVersion")
                        .WithMany("TestResults")
                        .HasForeignKey("SolutionVersionId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Tests.Test", "Test")
                        .WithMany("TestResults")
                        .HasForeignKey("TestId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.TagWithMetaData", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.MetaData", "MetaData")
                        .WithMany("TagWithMetaDatas")
                        .HasForeignKey("MetaDataId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Tag", "Tag")
                        .WithMany("TagWithMetaDatas")
                        .HasForeignKey("TagId");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.TemplateFile", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.CodeTemplate")
                        .WithMany("TemplateFiles")
                        .HasForeignKey("CodeTemplateId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.CustomTest", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Tests.TestType", "TestType")
                        .WithMany()
                        .HasForeignKey("TestTypeId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Solution.ExerciseReleaseWithUserAsParticipation")
                        .WithMany("CustomTests")
                        .HasForeignKey("UserId", "ExerciseReleaseId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.CustomTestAsset", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Tests.CustomTest")
                        .WithMany("TestAssets")
                        .HasForeignKey("CustomTestId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.DefaultCustomTestSettings", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithOne("DefaultCustomTestSettings")
                        .HasForeignKey("ClientServer.Models.Exercises.Tests.DefaultCustomTestSettings", "ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.Test", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Exercise", "Exercise")
                        .WithMany("Tests")
                        .HasForeignKey("ExerciseId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Tests.TestSettings", "TestSettings")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Exercises.Tests.Test", "TestSettingsId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Exercises.Tests.TestType", "TestType")
                        .WithMany()
                        .HasForeignKey("TestTypeId");
                });

            modelBuilder.Entity("ClientServer.Models.Exercises.Tests.TestAsset", b =>
                {
                    b.HasOne("ClientServer.Models.Exercises.Tests.Test")
                        .WithMany("TestAssets")
                        .HasForeignKey("TestId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Users.ExternalUser", b =>
                {
                    b.HasOne("ClientServer.Models.Users.User", "User")
                        .WithOne("ExternalUser")
                        .HasForeignKey("ClientServer.Models.Users.ExternalUser", "UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Users.GroupRole", b =>
                {
                    b.HasOne("ClientServer.Models.Users.GroupRolePermission", "GroupRolePermission")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.GroupRole", "GroupRolePermissionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Users.Settings.UserSetting", b =>
                {
                    b.HasOne("ClientServer.Models.Users.Settings.CodeEditorSetting", "CodeEditorSetting")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.Settings.UserSetting", "CodeEditorSettingsId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Lang", "Lang")
                        .WithMany()
                        .HasForeignKey("LangId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Users.User", "User")
                        .WithOne("UserSettings")
                        .HasForeignKey("ClientServer.Models.Users.Settings.UserSetting", "UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Users.SystemRole", b =>
                {
                    b.HasOne("ClientServer.Models.Users.SystemRolePermission", "SystemRolePermission")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.SystemRole", "SystemRolePermissionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("ClientServer.Models.Users.SystemSetting", b =>
                {
                    b.HasOne("ClientServer.Models.Users.GroupRole", "DefaultGroupCreatorGroupRole")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.SystemSetting", "DefaultGroupCreatorGroupRoleId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Users.GroupRole", "DefaultGroupRole")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.SystemSetting", "DefaultGroupRoleId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("ClientServer.Models.Users.UserGroup", "DefaultUserGroup")
                        .WithOne()
                        .HasForeignKey("ClientServer.Models.Users.SystemSetting", "DefaultUserGroupId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Users.User", b =>
                {
                    b.HasOne("ClientServer.Models.Users.SystemRole", "SystemRole")
                        .WithMany()
                        .HasForeignKey("SystemRoleId")
                        .OnDelete(DeleteBehavior.SetNull);
                });

            modelBuilder.Entity("ClientServer.Models.Users.UserWithUserGroup", b =>
                {
                    b.HasOne("ClientServer.Models.Users.GroupRole", "GroupRole")
                        .WithMany("UserUserGroups")
                        .HasForeignKey("GroupRoleId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Users.UserGroup", "UserGroup")
                        .WithMany("UserWithUserGroups")
                        .HasForeignKey("UserGroupId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ClientServer.Models.Users.User", "User")
                        .WithMany("UserWithUserGroups")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
        }
    }
}
